### R code from vignette source 'mcsSubset.Rnw'

###################################################
### code chunk number 1: preliminaries
###################################################
options(width = 70, prompt = "R> ", continue = "+  ")
library("mcsSubset")


###################################################
### code chunk number 2: AirPollution
###################################################
library("mcsSubset")
data("AirPollution", package = "mcsSubset")
for(i in 12:14) AirPollution[[i]] <- log(AirPollution[[i]])


###################################################
### code chunk number 3: mcsSubset
###################################################
xs <- mcsSubset(mortality ~ ., data = AirPollution)
xs


###################################################
### code chunk number 4: summary
###################################################
plot(xs)
summary(xs)


###################################################
### code chunk number 5: deviance
###################################################
deviance(xs)
logLik(xs)
AIC(xs)
AIC(xs, k = log(nrow(AirPollution)))


###################################################
### code chunk number 6: deviance-all
###################################################
deviance(xs, size = 1:16)
AIC(xs, size = 1:16)
AIC(xs, size = 1:16, k = log(nrow(AirPollution)))


###################################################
### code chunk number 7: refit
###################################################
lm5 <- refit(summary(xs))
summary(lm5)


